tmux: refactor

Consolidates the switch-adding logic for readability.
Replaces "[[ ... ]] && ..." with "if [[ ... ]]; then ..." in some cases to avoid a spurious nonzero exit status from _zsh_tmux_plugin_run.
Puts error message on stderr instead of stdout
This commit is contained in:
Andrew Janke 2015-09-27 22:22:50 -04:00
parent cd3858cf0e
commit 39fd8f9214

View File

@ -10,7 +10,7 @@ alias tkss='tmux kill-session -t'
# Only run if tmux is actually installed # Only run if tmux is actually installed
if ! which tmux &> /dev/null; then if ! which tmux &> /dev/null; then
print "zsh tmux plugin: tmux not found. Please install tmux before using this plugin." print "zsh tmux plugin: tmux not found. Please install tmux before using this plugin." >&2
return 1 return 1
fi fi
@ -40,7 +40,7 @@ fi
# Get the absolute path to the current directory # Get the absolute path to the current directory
local zsh_tmux_plugin_path="$(cd "$(dirname "$0")" && pwd)" local zsh_tmux_plugin_path=${0:h}
# Determine if the terminal supports 256 colors # Determine if the terminal supports 256 colors
if [[ `tput colors` == "256" ]]; then if [[ `tput colors` == "256" ]]; then
@ -60,17 +60,25 @@ fi
# Wrapper function for tmux. # Wrapper function for tmux.
function _zsh_tmux_plugin_run() { function _zsh_tmux_plugin_run() {
# We have other arguments, just run them local tmux_cmd
tmux_cmd=(command tmux)
[[ "$ZSH_TMUX_ITERM2" == "true" ]] && tmux_cmd+="-CC"
[[ "$ZSH_TMUX_FIXTERM" == "true" ]] && tmux_cmd+=(-f $_ZSH_TMUX_FIXED_CONFIG)
if [[ -n "$@" ]]; then if [[ -n "$@" ]]; then
# We have other arguments, just run them
\tmux $@ \tmux $@
# Try to connect to an existing session.
elif [[ "$ZSH_TMUX_AUTOCONNECT" == "true" ]]; then elif [[ "$ZSH_TMUX_AUTOCONNECT" == "true" ]]; then
\tmux `[[ "$ZSH_TMUX_ITERM2" == "true" ]] && echo '-CC '` attach || \tmux `[[ "$ZSH_TMUX_ITERM2" == "true" ]] && echo '-CC '` `[[ "$ZSH_TMUX_FIXTERM" == "true" ]] && echo '-f '$_ZSH_TMUX_FIXED_CONFIG` new-session # Try to connect to an existing session.
[[ "$ZSH_TMUX_AUTOQUIT" == "true" ]] && exit $tmux_cmd attach || $tmux_cmd new-session
# Just run tmux, fixing the TERM variable if requested. if [[ "$ZSH_TMUX_AUTOQUIT" == "true" ]]; then
exit
fi
else else
\tmux `[[ "$ZSH_TMUX_ITERM2" == "true" ]] && echo '-CC '` `[[ "$ZSH_TMUX_FIXTERM" == "true" ]] && echo '-f '$_ZSH_TMUX_FIXED_CONFIG` # Just run tmux, fixing the TERM variable if requested.
[[ "$ZSH_TMUX_AUTOQUIT" == "true" ]] && exit $tmux_cmd
if [[ "$ZSH_TMUX_AUTOQUIT" == "true" ]]; then
exit
fi
fi fi
} }